"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("react");
var props_1 = require("../../../utilities/props");
var Styled = require("./style");
var TAGS = {
    p: Styled.Paragraph,
    span: Styled.Span,
    strong: Styled.Strong,
    b: Styled.Bold,
    em: Styled.Emphasis,
    i: Styled.Italic,
    q: Styled.Quote,
    mark: Styled.Mark,
};
/**
 * Text Component
 */
var Text = (0, react_1.forwardRef)(function (props, forwardedRef) {
    var tag = props.tag;
    var style = __assign(__assign(__assign({}, (0, props_1.getWhiteSpaceProps)(props)), (0, props_1.getFontProps)(props)), props.style);
    var Tag = TAGS[tag];
    return (0, jsx_runtime_1.jsx)(Tag, __assign({}, props, { ref: forwardedRef, style: style }));
});
exports.default = Text;
