"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var Styled = require("./style");
var react_1 = require("react");
var props_1 = require("../../../utilities/props");
var lodash_1 = require("lodash");
/**
 * TextField Component
 */
var TextField = (0, react_1.forwardRef)(function (props, forwardedRef) {
    var label = props.label, regex = props.regex;
    var _a = (0, react_1.useState)(false), active = _a[0], setActive = _a[1];
    var handleInput = (0, react_1.useCallback)(function (e) {
        e.currentTarget.value = e.currentTarget.value.replace(regex !== null && regex !== void 0 ? regex : "", "");
        props.onInput && props.onInput(e);
    }, [regex]);
    var handleFocus = (0, react_1.useCallback)(function (e) {
        setActive(true);
        props.onFocus && props.onFocus(e);
    }, []);
    var handleBlur = (0, react_1.useCallback)(function (e) {
        setActive(false);
        props.onBlur && props.onBlur(e);
    }, []);
    var style = __assign(__assign(__assign(__assign({}, (0, props_1.getSizeProps)(props)), (0, props_1.getWhiteSpaceProps)(props)), (0, props_1.getFontProps)(props)), props.style);
    return ((0, jsx_runtime_1.jsxs)(Styled.Container, __assign({ active: active, style: style }, { children: [(0, jsx_runtime_1.jsx)(Styled.Input, __assign({}, lodash_1.default.omit(props, "style"), { ref: forwardedRef, onInput: handleInput, onFocus: handleFocus, onBlur: handleBlur })), (0, jsx_runtime_1.jsx)(Styled.Label, { children: label })] })));
});
exports.default = TextField;
