"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var Style = require("./style");
var react_1 = require("react");
var time_1 = require("../../../types/time");
var useClickOutside_1 = require("../../../hooks/useClickOutside");
var useSetScrollPosition_1 = require("../../../hooks/useSetScrollPosition");
var useModal_1 = require("../../../hooks/useModal");
var useCursor_1 = require("../../../hooks/useCursor");
var TimeType_1 = require("./TimeType");
var Hour_1 = require("./Hour");
var Min_1 = require("./Min");
var Seconds_1 = require("./Seconds");
var ArrowButton_1 = require("../../common/ArrowButton");
var TimePicker = function (_a) {
    var handleSelect = _a.handleSelect, _b = _a.is24Hour, is24Hour = _b === void 0 ? false : _b, _c = _a.isSelectHour, isSelectHour = _c === void 0 ? true : _c, _d = _a.isSelectMin, isSelectMin = _d === void 0 ? true : _d, _e = _a.isSelectSeconds, isSelectSeconds = _e === void 0 ? false : _e, _f = _a.maxItemCount, maxItemCount = _f === void 0 ? 6 : _f, _g = _a.width, width = _g === void 0 ? 200 : _g, _h = _a.height, height = _h === void 0 ? 35 : _h, containerActiveStyle = _a.containerActiveStyle, containerInactiveStyle = _a.containerInactiveStyle, selectWrapperActiveStyle = _a.selectWrapperActiveStyle, selectWrapperInactiveStyle = _a.selectWrapperInactiveStyle, listContainerStyle = _a.listContainerStyle, listStyle = _a.listStyle, itemStyle = _a.itemStyle;
    var _j = (0, useModal_1.default)(), isOpen = _j.isOpen, setIsOpen = _j.setIsOpen, handleOpenClick = _j.handleOpenClick;
    var _k = (0, react_1.useState)(new time_1.Time({ hour: 0, min: 0, seconds: 0 })), time = _k[0], setTime = _k[1];
    var _l = (0, react_1.useState)(time_1.TIME_TYPE.AM), timeType = _l[0], setTimeType = _l[1];
    var _m = (0, react_1.useState)(12), hour = _m[0], setHour = _m[1];
    var _o = (0, react_1.useState)(0), min = _o[0], setMin = _o[1];
    var _p = (0, react_1.useState)(0), seconds = _p[0], setSeconds = _p[1];
    var containerRef = (0, react_1.useRef)(null);
    var inputRef = (0, react_1.useRef)(null);
    var timeTypeRef = (0, react_1.useRef)(null);
    var hourRef = (0, react_1.useRef)(null);
    var minRef = (0, react_1.useRef)(null);
    var secondsRef = (0, react_1.useRef)(null);
    var _q = (0, useCursor_1.default)(inputRef, time), cursor = _q.cursor, setCursor = _q.setCursor;
    (0, useClickOutside_1.default)(containerRef, setIsOpen);
    (0, useSetScrollPosition_1.default)(hourRef, is24Hour ? hour * height : (hour % 12) * height, isOpen);
    (0, useSetScrollPosition_1.default)(minRef, min * height, isOpen);
    (0, useSetScrollPosition_1.default)(secondsRef, seconds * height, isOpen);
    (0, react_1.useEffect)(function () {
        var newTime = new time_1.Time({
            hour: !is24Hour
                ? timeType === time_1.TIME_TYPE.PM
                    ? hour + 12 === 24
                        ? 12
                        : hour + 12
                    : hour === 12
                        ? 0
                        : hour
                : hour,
            min: min,
            seconds: seconds,
        });
        setTime(newTime);
        handleSelect(newTime);
    }, [timeType, hour, min, seconds]);
    var handleChange = (0, react_1.useCallback)(function (e) {
        var _a, _b;
        var event = e.nativeEvent;
        if (!((_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.selectionStart) || !event.data)
            return;
        var data = +event.data;
        var cursor = ((_b = inputRef.current) === null || _b === void 0 ? void 0 : _b.selectionStart) - 1;
        var standardPoint = 0;
        if (!is24Hour) {
            var isCursorInsideTimeType = cursor >= standardPoint && cursor <= standardPoint + 1;
            if (isCursorInsideTimeType) {
                setTimeType(data === 1 ? time_1.TIME_TYPE.AM : time_1.TIME_TYPE.PM);
                setCursor(standardPoint + 2);
            }
            standardPoint += 2;
        }
        else {
            standardPoint -= 1;
        }
        if (isSelectHour) {
            var isCursorInsideHourFirstDigit = cursor >= standardPoint && cursor <= standardPoint + 1;
            if (isCursorInsideHourFirstDigit) {
                if (data >= 0 && data <= 1) {
                    setHour(data * 10);
                    setCursor(standardPoint + 2);
                }
                else {
                    setHour(data);
                    setCursor(standardPoint + 4);
                }
            }
            var isCursorInsideHourSecondDigit = cursor === standardPoint + 2;
            if (isCursorInsideHourSecondDigit) {
                if (data >= 0 && data <= 2) {
                    setHour(function (prev) { return Math.floor(prev / 10) * 10 + data; });
                }
                else {
                    setHour(data);
                }
                setCursor(standardPoint + 4);
            }
            standardPoint += 3;
        }
        if (isSelectMin) {
            var isCursorInsideMinFirstDigit = cursor >= standardPoint && cursor <= standardPoint + 1;
            if (isCursorInsideMinFirstDigit) {
                if (data >= 0 && data <= 5) {
                    setMin(data * 10);
                    setCursor(standardPoint + 2);
                }
                else {
                    setMin(data);
                    setCursor(standardPoint + 4);
                }
            }
            var isCursorInsideMinSecondDigit = cursor === standardPoint + 2;
            if (isCursorInsideMinSecondDigit) {
                setMin(function (prev) { return Math.floor(prev / 10) * 10 + data; });
                setCursor(standardPoint + 4);
            }
            standardPoint += 3;
        }
        if (isSelectSeconds) {
            var isCursorInsideSecondsFirstDigit = cursor >= standardPoint && cursor <= standardPoint + 1;
            if (isCursorInsideSecondsFirstDigit) {
                if (data >= 0 && data <= 5) {
                    setSeconds(data * 10);
                    setCursor(standardPoint + 2);
                }
                else {
                    setSeconds(data);
                    setCursor(standardPoint + 3);
                }
            }
            var isCursorInsideSecondsSecondDigit = cursor === standardPoint + 2;
            if (isCursorInsideSecondsSecondDigit) {
                setSeconds(function (prev) { return Math.floor(prev / 10) * 10 + data; });
                setCursor(standardPoint + 3);
            }
            standardPoint += 2;
        }
        if (cursor === standardPoint) {
            setCursor(0);
        }
    }, [is24Hour, isSelectHour, isSelectMin, isSelectSeconds]);
    return ((0, jsx_runtime_1.jsxs)(Style.Container, __assign({ ref: containerRef, active: isOpen, maxItemCount: maxItemCount, width: width, height: height, style: isOpen ? containerActiveStyle : containerInactiveStyle }, { children: [(0, jsx_runtime_1.jsxs)(Style.SelectWrapper, __assign({ isOpen: isOpen, height: height, style: isOpen ? selectWrapperActiveStyle : selectWrapperInactiveStyle }, { children: [(0, jsx_runtime_1.jsx)(Style.Input, { ref: inputRef, value: !is24Hour
                            ? time.getString({
                                isPrintTimeType: true,
                                isPrintHour: isSelectHour,
                                isPrintMin: isSelectMin,
                                isPrintSeconds: isSelectSeconds,
                            })
                            : time.getString24Hour({
                                isPrintHour: isSelectHour,
                                isPrintMin: isSelectMin,
                                isPrintSeconds: isSelectSeconds,
                            }), onChange: function (e) { return handleChange(e); } }), (0, jsx_runtime_1.jsx)(ArrowButton_1.default, { handleOpenClick: handleOpenClick, isOpen: isOpen, direction: isOpen ? "Up" : "Down" })] })), isOpen && ((0, jsx_runtime_1.jsxs)(Style.ListContainer, __assign({ maxItemCount: maxItemCount, height: height, style: listContainerStyle }, { children: [!is24Hour && ((0, jsx_runtime_1.jsx)(TimeType_1.default, { timeTypeRef: timeTypeRef, timeType: timeType, setTimeType: setTimeType, height: height, listStyle: listStyle, itemStyle: itemStyle })), isSelectHour && ((0, jsx_runtime_1.jsx)(Hour_1.default, { hourRef: hourRef, hour: hour, setHour: setHour, is24Hour: is24Hour, height: height, listStyle: listStyle, itemStyle: itemStyle })), isSelectMin && ((0, jsx_runtime_1.jsx)(Min_1.default, { minRef: minRef, min: min, setMin: setMin, height: height, listStyle: listStyle, itemStyle: itemStyle })), isSelectSeconds && ((0, jsx_runtime_1.jsx)(Seconds_1.default, { secondsRef: secondsRef, seconds: seconds, setSeconds: setSeconds, height: height, listStyle: listStyle, itemStyle: itemStyle }))] })))] })));
};
exports.default = TimePicker;
