"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var useThrottle = function (callback, timeout) {
    var _a = (0, react_1.useState)(true), ready = _a[0], setReady = _a[1]; // ready 상태에서만 콜백이 실행됨
    var timerRef = (0, react_1.useRef)();
    var throttledFunction = (0, react_1.useCallback)(function () {
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            params[_i] = arguments[_i];
        }
        if (!ready)
            return; // ready 상태가 아니면 아무것도 실행하지 않음
        setReady(false); // ready 상태이면 다시 false로 바꾸고
        callback.apply(void 0, params); // 콜백을 실행함
    }, [ready, callback]);
    (0, react_1.useEffect)(function () {
        timerRef.current = setTimeout(function () {
            setReady(true); // 대기 시간이 지나면 ready 상태를 true로 바꿈
        }, timeout);
        return function () {
            clearTimeout(timerRef.current);
        };
    }, [ready, timeout]);
    return throttledFunction;
};
exports.default = useThrottle;
