"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDefaultColor = exports.getPrimaryColor = exports.getColorByStatus = void 0;
var getColorByStatus = function (props) {
    return props.active ? (0, exports.getPrimaryColor)(props) : (0, exports.getDefaultColor)(props);
};
exports.getColorByStatus = getColorByStatus;
var getPrimaryColor = function (props) {
    var _a, _b;
    if ("primaryColor" in props)
        return (_a = props.primaryColor) !== null && _a !== void 0 ? _a : "gray";
    return (_b = props.theme.primaryColor) !== null && _b !== void 0 ? _b : "gray";
};
exports.getPrimaryColor = getPrimaryColor;
var getDefaultColor = function (props) {
    var _a, _b;
    if ("defaultColor" in props)
        return (_a = props.defaultColor) !== null && _a !== void 0 ? _a : "gray";
    return (_b = props.theme.defaultColor) !== null && _b !== void 0 ? _b : "gray";
};
exports.getDefaultColor = getDefaultColor;
