var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import { useCallback, useRef, useState } from "react";
import useClickOutside from "../../../hooks/useClickOutside";
import ArrowButton from "../../../components/common/ArrowButton";
import useSetScrollPosition from "../../../hooks/useSetScrollPosition";
import { getSizeProps } from "../../../utilities/props";
import useActive from "../../../hooks/useActive";
import _ from "lodash";
import * as Styled from "./style";
var Select = function (props) {
    var _a, _b, _c;
    var children = props.children, value = props.value, placeholder = props.placeholder, onChange = props.onChange, _d = props.isSearchable, isSearchable = _d === void 0 ? false : _d, _e = props.showItemCount, showItemCount = _e === void 0 ? 8 : _e, listStyle = props.listStyle, itemStyle = props.itemStyle;
    var childrens = _.isArray(children) ? children : [children];
    var _f = useActive(), active = _f.active, setActive = _f.setActive, handleActive = _f.handleActive;
    var _g = useState(""), search = _g[0], setSearch = _g[1];
    var _h = useState(childrens), result = _h[0], setResult = _h[1];
    var containerRef = useRef(null);
    var listRef = useRef(null);
    var itemRef = useRef(null);
    useClickOutside(containerRef, setActive);
    useSetScrollPosition(listRef, result.findIndex(function (item) { return item === value; }) *
        ((_b = (_a = itemRef.current) === null || _a === void 0 ? void 0 : _a.clientHeight) !== null && _b !== void 0 ? _b : 0), active);
    var handleKeyDown = useCallback(function (e) {
        switch (e.nativeEvent.key) {
            case "Enter":
                var find = childrens.find(function (item) { return (item === null || item === void 0 ? void 0 : item.props.value) === search; });
                find && dispatchInput(find.props.value + "");
                break;
            case "Escape":
                setActive(false);
                break;
            default:
                var filter = childrens.filter(function (item) {
                    return ((item === null || item === void 0 ? void 0 : item.props.value) + "").includes(search);
                });
                setResult(filter);
                setActive(true);
        }
    }, [search]);
    var handleChange = useCallback(function (e) {
        onChange(e);
        setSearch(e.target.value);
    }, []);
    var handleFocus = useCallback(function (e) {
        setActive(true);
        // props.onFocus && props.onFocus(e);
    }, []);
    var dispatchInput = useCallback(function (value) {
        var _a;
        var input = (_a = containerRef.current) === null || _a === void 0 ? void 0 : _a.getElementsByTagName("input")[0];
        if (input) {
            var lastValue = input.value;
            input.value = value;
            setSearch(value);
            var event_1 = new Event("input", { bubbles: true });
            var tracker = input._valueTracker;
            if (tracker) {
                tracker.setValue(lastValue);
            }
            input.dispatchEvent(event_1);
        }
        setActive(false);
    }, []);
    var showItemCountValue = Math.max(childrens.length, showItemCount);
    var style = __assign(__assign({}, getSizeProps(props)), props.style);
    return (_jsxs(Styled.Container, __assign({ ref: containerRef, active: active, style: style }, { children: [isSearchable ? (_jsx(Styled.Input, { value: search, placeholder: placeholder, onChange: handleChange, onFocus: handleFocus, onKeyUp: function (e) { return handleKeyDown(e); } })) : (_jsx(Styled.Input, { value: value, placeholder: placeholder, onChange: handleChange, onFocus: handleFocus, readOnly: true })), _jsx(ArrowButton, { handleOpenClick: handleActive, isOpen: active, direction: active ? "Up" : "Down" }), active && (_jsx(Styled.List, __assign({ ref: listRef, itemHeight: (_c = itemStyle === null || itemStyle === void 0 ? void 0 : itemStyle.height) !== null && _c !== void 0 ? _c : "35px", showItemCount: showItemCountValue, style: listStyle }, { children: result.map(function (item, index) { return (_jsx(Styled.Item, __assign({ ref: itemRef, active: value === item.props.value, onClick: function () { return dispatchInput(item.props.value); }, style: itemStyle }, { children: item.props.children }), index)); }) })))] })));
};
export default Select;
