import { useRef } from "react";
var uesDebounce = function (callback, timeout) {
    var timerRef = useRef(null);
    return function () {
        var params = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            params[_i] = arguments[_i];
        }
        if (timerRef.current)
            clearTimeout(timerRef.current); // setTimeout을 제거함
        // 대기 시간이 지나기전에 콜백이 재 실행되면 clearTimeout에 의해서 아무것도 실행되지 않음
        timerRef.current = setTimeout(function () {
            callback.apply(void 0, params); // 대기 시간이 지나면 콜백을 실행함
            timerRef.current = null;
        }, timeout);
    };
};
export default uesDebounce;
